             ;PROGRAMA DEFINITIVO CON DISPLAY LCD...11-10-1996
             ; RUTINAS PROGRAMA MONITOR


;CLS.........INICIALIZACION
;PRESE.......PRESENTACION DEL SISTEMA
;TECLAD......OBTENCION DE LA FUNCION PULSADA
;GO..........EJECUTAR A PARTIR DE UNA DIRECCION
;DISPLAY.....TRASLADA Y VISUALIZA DIRECCIONES Y DATOS
;SEPDAT......SEPARA UN DATO DE 8 BITS EN DOS DE 4
;SEPDIR......SEPARA UNA DIRECCION DE 16 BITS EN CUATRO DE 4
;OBTDIR......OBTIENE UNA DIRECCION
;OBTDAT......OBTIENE UN DATO
;MEMOR.......EXAMINA Y MODIFICA UNA POSICION DE MEMORIA
;ERROR.......RUTINA DE PRESENTACION DE ERROR
;TECLADO.....OBTENCION DE LA TECLA PULSADA
;REG.........EXAMINA Y MODIFICA LOS REGISTROS
;PEPRO.......GRABAR UNA EPROM
;PERROR......ERROR EN LA RUTINA DE GRABAR EPROM
;RETARDO.....RUTINA DE PERDIDA DE TIEMPO
;PASO........RUTINA DE PASO A PASO
;INI.........OBTENCION DE LA VELOCIDAD DE TRANSMISION SERIE
;ENVIO.......ENVIO DE DATOS POR LA LINEA SERIE
;COUT........ENVIA UN DATO POR LA LINEA SERIE
;CINP........RECIBE UN DATO POR LA LINEA SERIE
;TECLSE......OBTENCION DE LA FUNCION DESDE LA LINEA SERIE
;DISPLSE.....TRASLADA Y VISUALIZA DIRECCIONES A TRAVES DE LA LINEA SERIE
;DISDSE......TRASLADA Y VISUALIZA UN DATO A TRAVES DE LA LINEA SERIE
;TECLASE.....OBTENCION DE LA TECLA PULSADA POR LA LINEA SERIE
;COMSER......PROGRAMA DE COMUNICACION SERIE
;PARAL.......RECIBE DATOS DE UN PC A TRAVES DEL PUERTO PARALELO(*.OBJ o *.NTL)        
;BORRAR......BORRA LOS DATOS Y DIRECCIONES DE LA MEMORIAS POSTEX9 A POSTEXF
;REPROG......RUTINA DE PROGRAMACION DEL RETARDO "TIEMPO".
;TIEMPO......RUTINA DE RETARDO PROGRAMADA POR "REPROG".
;BINAR.......CONVIERTE LOS DATOS EN BINARIO Y LO REPRESENTA EN LCD.



;POSICIONES RAM 
POS0    EQU     DF00H     ;VALOR ULTIMA TECLA PULSADA
POS1    EQU     DF01H     ;SEMI-BYTE ALTO DE LA DIRECCION
POS2    EQU     DF02H     ;SEMI-BYTE SEMI-ALTO DE LA DIRECCION
POS3    EQU     DF03H     ;SEMI-BYTE SEMI-BAJO DE LA DIRECCION
POS4    EQU     DF04H     ;SEMI-BYTE BAJO DE LA DIRECCION
POS5    EQU     DF05H     ;SEMI-BYTE ALTO DEL DATO
POS6    EQU     DF06H     ;SEMI-BYTE BAJO DEL DATO
POS7    EQU     DF07H     ;ERROR = a "0" NO EXISTE ERROR
POS8    EQU     DF08H     ;CODIGO EN HEX. DE CALL
POS9    EQU     DF09H     ;BYTE BAJO DE LA DIRECCION
POSA    EQU     DF0AH     ;BYTE ALTO DE LA DIRECCION
POSB    EQU     DF0BH     ;CODIGO EN HEX. DE RET
POSC    EQU     DF0CH     ;BYTE DATO
POSD    EQU     DF0DH     ;RUTINA REG PARA GUARDAR EL REGISTRO DE ESTADO
POSE    EQU     DF0EH     ;   "    "   "      "    "    "       A
POSF    EQU     DF0FH     ;                                     C
POS10   EQU     DF10H     ;                                     B
POS11   EQU     DF11H     ;                                     E
POS12   EQU     DF12H     ;                                     D
POS13   EQU     DF13H     ;                                     L
POS14   EQU     DF14H     ;                                     H
POS15   EQU     DF15H     ;                            PC BYTE BAJO 
POS16   EQU     DF16H     ;                            PC BYTE ALTO  
POS17   EQU     DF17H     ;                           VALOR ULTIMA TECLA
POS18   EQU     DF18H     ;                           SEMI-BYTE ALTO DIR  
POS19   EQU     DF19H     ;                           SEMI-BYTE SEMI-ALTO DIR 
POS1A   EQU     DF1AH     ;                           SEMI-BYTE SEMI-BAJO DIR  
POS1B   EQU     DF1BH     ;                           SEMI-BYTE BAJO DIR
POS1C   EQU     DF1CH     ;                           SEMI-BYTE ALTO DATO 
POS1D   EQU     DF1DH     ;                           SEMI-BYTE BAJO DATO
POS1E   EQU     DF1EH     ;                           ERROR
POS1F   EQU     DF1FH     ;                           CODIGO CALL
POSDF   EQU     DFDFH     ;                           BYTE BAJO DIR
POS21   EQU     DF21H     ;                           BYTE ALTO DIR
POS22   EQU     DF22H     ;                           CODIGO RET
POS23   EQU     DF23H     ;                           BYTE DATO
POS24   EQU     DF24H     ;
POS25   EQU     DF25H     ;
POS26   EQU     DF26H     ;
POSSE   EQU     DF2FH     ;POSICION A "1" ES SERIE
POSTEX0 EQU     DF30H
POSTEX1 EQU     DF31H     ;POSICIONES PARA MENSAJES EN LCD Y COMUNICACION
POSTEX2 EQU     DF32H     ;SERIE EN ASCII, HASTA DF3FH
POSTEX3 EQU     DF33H
POSTEX4 EQU     DF34H
POSTEX5 EQU     DF35H
POSTEX6 EQU     DF36H
POSTEX7 EQU     DF37H
POSTEX8 EQU     DF38H
POSTEX9 EQU     DF39H
POSTEXA EQU     DF3AH
POSTEXB EQU     DF3BH
POSTEXC EQU     DF3CH
POSTEXD EQU     DF3DH
POSTEXE EQU     DF3EH
POSTEXF EQU     DF3FH
;DE LA POS      DF40H A  DF4FH LA UTILIZA EL LCD PARA REPRESENTAR EN BINARIO
POSV    EQU     DF53H
POSV1   EQU     DF54H
POSMEN1 EQU     DF50H     ;POSICION ALTA DEL MENSAJE EN LCD (AUN NO EXISTE)
POSMEN2 EQU     DF51H     ;POSICION BAJA PARA EL BYTE DEL MENSAJE EN LCD
POSREP1 EQU     DF55H     ;POSICION 1 PARA EL RETARDO PROGRAMABLE
POSREP2 EQU     DF56H     ;POSICION 2  "         "         "
PCONTR  EQU     8000H

PORTC2  EQU     DF60H     ;POSICION PARA GUARDAR EL REGISTRO DE ESTADO DEL 8255
PORTCR  EQU     E000H     ;REGISTRO DE PIA
PORTA   EQU     E001H     ;PUERTO A PIA
PORTB   EQU     E002H     ;PUERTO B PIA
PORTC   EQU     E003H     ;PUERTO C PIA

;MAPA DE MEMORIA

;EPROM.....................0000H
;DISPLAY LCD...............8000H ...CARGA DE DATOS
;EEPROM Y AMPLIACIONES.....A000H
;RAM.......................C000H
;8255......................E000H
;AMPLIACIONES..............2000H
;AMPLIACIONES..............4000H
;AMPLIACIONES..............6000H
;TECLADO SERIE.............PUERTO A DEL 8255
;SALIDA PARALELO...........PUERTO B DEL 8255
;SALIDA SERIE..............SID Y SOD
;CONTROL LCD...............PC6=R/S Y PC7=E..WE=0

             ORG 0000H
             MVI H,20H
             MVI L,0FFH
             SPHL
             JMP CLS

             ORG 0024H
             JMP 2040H        ;TRAP

             ORG 003CH
             JMP PASO        ;RST 7.5

             ORG 0034H
             DI          
             JMP CLS         ;RST 6.5

             ORG 002CH
             JMP REG         ;RST 5.5

             ORG 0008H
             JMP 2048H        ;RST 1

             ORG 0010H
             JMP 2050H        ;RST 2

             ORG 0018H
             JMP 2058H        ;RST 3

             ORG 0020H
             JMP 2060H        ;RST 4

             ORG 0028H
             JMP 2068H        ;RST 5

             ORG 0030H
             JMP 2070H        ;RST 6

             ORG 0038H
             JMP 2078H        ;RST 7


             ORG 0100H
CLS      MVI A,18H   
         SIM
         EI
         MVI A,00H
         STA POS0
         STA POS1
         STA POS2
         STA POS3
         STA POS4
         STA POS5
         STA POS6
         STA POS7
         STA POS8
         STA POS9
         STA POSA
         STA POSB
         STA POSC
         STA POSSE
         MOV B,A
         MOV C,A
         MOV D,A
         MOV E,A
         MOV H,A
         MOV L,A
         MVI A,0CDH
         STA POS8
         MVI A,0C9H
         STA POSB
         DS 20H
PRESE   MVI A,4DH        ;"M" EN ASCII
        STA POSTEX0
        MVI A,49H        ;"I" EN ASCII
        STA POSTEX1
        MVI A,43H        ;"C" EN ASCII
        STA POSTEX2
        MVI A,52H        ;"R" EN ASCII
        STA POSTEX3
        MVI A,4FH        ;"O" EN ASCII
        STA POSTEX5   
        MVI A,2DH        ;"-" EN ASCII
        STA POSTEX6
        MVI A,20H
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        MVI A,08H
        STA POS1
        STA POS3
        MVI A,00H
        STA POS2   
        MVI A,05H
        STA POS4
        CALL DISPLAY
        JMP TECLAD
        DS 20H



TECLAD  LDA POSSE
        CPI 01H
        CZ TECLSE













        STA POS0                                  
        CPI 10H
        CZ GO            ;EJECUTAR
        CPI 11H
        CZ COMSER        ;COMUNICACION SERIE
        CPI 12H
        CZ MEMOR         ;ACCESO A MEMORIA
        CPI 17H
        CZ PEPRO         ;GRABAR EPROMS
        CPI 0FH
        CZ PARAL         ;COMUNICACION PARALELO
        CPI 0BH
        CZ REPROG        ;PROGAMACION DEL RETARDO
        JMP TECLAD
        DS 20H

GO      MVI A,00H
        STA POS7
        MVI A,45H        ;"E"   EN ASCII
        STA POSTEX0
        STA POSTEX2
        MVI A,4AH        ;"J"
        STA POSTEX1      ;"E"
        MVI A,43H        ;"C"
        STA POSTEX3
        MVI A,55H        ;"U"
        STA POSTEX4
        MVI A,54H        ;"T"
        STA POSTEX5
        MVI A,41H        ;"A"
        STA POSTEX6
        MVI A,52H        ;"R"
        STA POSTEX7
        MVI A,3AH        ;":"
        STA POSTEX8
        MVI A,20H        ;ESPACIO"
        STA POSTEX9
        MVI A,00H
        STA POSTEXA
        CALL BORRAR
        CALL DISPLAY
        CALL OBTDIR
        CALL TECLADO
        LDA POS0
        CPI 16H
        CNZ ERROR
        LDA POS7
        CPI 01H
        JZ GO
        MVI H,20H
        MVI L,0FFH
        SPHL
        MVI A,00H
        MOV H,A
        MOV L,A
        MOV D,A
        MOV E,A
        MOV B,A
        MOV C,A
        PUSH H
        POP PSW
        CALL POS8
        RET
        DS 20H

DISPLAY PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        LDA POSSE
        CPI 01H
        JZ DISPLSE
        LXI H,2000H
        LXI B,2038H     
        MVI A,20H        ;ESPACIO EN ASCII
        STAX B           ;A PARTIR DE LA POSICION 2039H SE PONDRAN LOS
PRIN1   INX H            ;DATOS NUMERICOS, LOS TEXTOS HASTA LA 2037H(POSTEX7)
        INX B            ;LA 2038H SIEMPRE SERA UN ESPACIO.(POSTEX8)
        MOV A,M
        CPI 0AH          ;SI ES MENOR DE 0AH ES QUE ES UN NUMERO
        JP LETR1         ;SI ES MAYOR SALTA A LETR1 POR SER UNA LETRA
        ADI 30H
        STAX B
        MOV A,L
        CPI 05H
        JNZ PRIN1
        MVI A,2DH        ;"-" EN ASCII
        STA POSTEXD      ;LO PONEMOS PARA SEPARAR EL DATO DE LA DIRECCION
        LXI H,2004H      ;IGUAL A PRIN1 PERO CON LOS DATOS
        LXI B,203DH  
PRIN2   INX H     
        INX B
        MOV A,M
        CPI 0AH
        JP LETR2
        ADI 30H
        STAX B
        MOV A,L
        CPI 07H
        JNZ PRIN2
        CALL BINAR
        LDA PORTCR
        STA PORTC2       ;GUARDAMOS EL REGISTRO PARA DEVOLVERLO LUEGO A SU ESTADO
        MVI A,FFH
        STA PORTCR       ;REGISTRO DE ESTADO DEL 8255,COMO SALIDAS
VISUA   MVI A,01H        ;BORRA PANTALLA
        CALL CONTROL
        MVI A,02H        ;POSICION INICIAL
        CALL CONTROL
        MVI A,38H        ;2 LINEAS DEL DISPLAY
        CALL CONTROL
        MVI A,06H        ;QUE SE DESPLACE A LA DERECHA
        CALL CONTROL
        MVI A,0CH        ;ENCIENDE VISUALIZADOR Y CURSOR ESTATICO
        CALL CONTROL
        MVI H,20H
        MVI L,2FH   ;UNA POSICION MENOS DONDE SE ENCUENTRA EL MENSAJE.
MASSS   INX H
        MOV A,M
        CALL ESCRIB
        MVI A,50H      ;UNA POSICION MAS DEL FINAL DEL MENSAJE (32 POSICIONES)
        JNZ MASSS      ;MENSAJE DESDE LA 2030H A 204FH 
        LDA PORTC2
        STA PORTCR
        POP D
        POP B
        POP PSW
        POP H
        RET



LETR1   ADI 37H
        STAX B
        MOV A,L
        CPI 05H
        JNZ PRIN1
        JMP VISUA 
LETR2   ADI 37H     
        STAX B
        MOV A,L
        CPI 07H
        JNZ PRIN2
        JMP VISUA
        

CONTROL MOV B,A          ;GUARDAMOS EL ACUMULADOR EN B
        STA 8000H        ;POSICION DATOS PARA EL DISPLAY
        MVI A,00H
        STA PORTC        ;Pc6---E...Pc7---R/S DEL DISPLAY
        MVI A,40H        ;PC6 A "1" QUE HABILITA EL DISPLAY
        STA PORTC        ;DIRECCION DEL PUERTO C
        MVI A,00H
        STA PORTC        ;DESHABILITAMOS EL DISPLAY
        CALL RETRASO
        RET


ESCRIB  MOV C,A         ;GUARDAMOS EL ACUMULADOR EN C
        STA 8000H       ;DIRECCION DATOS DISPLAY
        MVI A,80H       ;PONEMOS A "1" LA LINEA 7 DEL PUERTO C QUE ES R/S
        STA PORTC       ;DIRECCION DE CONTROL DEL 8255 PUERTO C (R/S-Pc7)
        MVI A,0C0H      ;ACTIVAMOS A "1" PC7 Y PC6
        STA PORTC       ;DIRECCION DEL PUERTO C
        MVI A,00H
        STA PORTC       ;PONEMOS A "0" PC7 Y PC6
        CALL RETRASO
        RET
       

RETRASO PUSH H
        PUSH PSW
        PUSH B
        PUSH D
RETR1   MVI E,0FFH
RETR2   DCR E
        JNZ RETA2
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H




SEPDAT  PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        LDA POSC
        ANI 0F0H
        RRC
        RRC
        RRC
        RRC
        STA POS5
        LDA POSC
        ANI 0FH
        STA POS6
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

SEPDIR  PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        LDA POSA
        ANI 0F0H
        RRC
        RRC
        RRC
        RRC
        STA POS1
        LDA POSA
        ANI 0FH
        STA POS2
        LDA POS9
        ANI 0F0H
        RRC
        RRC
        RRC
        RRC
        STA POS3
        LDA POS9
        ANI 0FH
        STA POS4
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

OBTDIR  PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI A,29H        ;VACIO PARA ESTAS POSICIONES
        STA POS1
        STA POS2
        STA POS3
        STA POS4
ETIQ    MVI A,00H
        STA POS7
        MVI H,20H
        MVI L,01H
ETIQ1   CALL TECLADO
        LDA POS0
        CPI 10H
        CP ERROR
        MOV M,A
        LDA POS7
        CPI 01H
        JZ ETIQ
        CALL DISPLAY
        INX H
        MVI A,05H
        CMP L
        JNZ ETIQ1
        LDA POS1
        ANI 0FH
        RLC
        RLC
        RLC
        RLC
        MOV B,A
        LDA POS2
        ANI 0FH
        ADD B
        STA POSA
        LDA POS3
        ANI 0FH
        RLC
        RLC
        RLC
        RLC
        MOV B,A
        LDA POS4
        ANI 0FH
        ADD B
        STA POS9
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

OBTDAT  PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI A,29H
        STA POS5
        STA POS6
ETI     MVI A,00H
        STA POS7
        MVI H,20H
        MVI L,05H
ETI1    CALL TECLADO
        LDA POS0
        CPI 10H
        CP ERROR
        MOV M,A
        LDA POS7
        CPI 01H
        JZ ETI
        CALL DISPLAY
        INX H
        MVI A,07H
        CMP L
        JNZ ETI1
        LDA POS5
        ANI 0FH
        RLC
        RLC
        RLC
        RLC
        MOV B,A
        LDA POS6
        ANI 0FH
        ADD B
        STA POSC
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

MEMOR   PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI A,4DH
        STA POSTEX0      ;"MEMORIA" EN ASCII
        STA POSTEX2
        MVI A,45
        STA POSTEX1
        MVI A,4FH
        STA POSTEX3
        MVI A,52H
        STA POSTEX4
        MVI A,49H
        STA POSTEX5
        MVI A,41H
        STA POSTEX6
        MVI A,20H
        STA POSTEX7
        MVI A,00H
        STA POSTEX8
        CALL BORRAR
        CALL DISPLAY
        CALL OBTDIR
        LDA POS7
        CPI 01H
        JZ PRESE
        CALL TECLADO
        LDA POS0
        CPI 16H
        JNZ PRESE
        LHLD POS9
SALTO5  MOV A,M
        STA POSC
        CALL SEPDAT
        CALL DISPLAY
SALTO6  MVI D,20H
        MVI E,05H
SALTO4  CALL TECLADO
        LDA POS0
        CPI 13H
        JZ SALTO1
        CPI 14H
        JZ SALTO2
        CPI 16H
        JZ SALTO3
        CPI 10H
        JP SALTO4
        STAX D
        CALL DISPLAY
        INX D
        MVI A,07H
        CMP E
        JNZ SALTO4
        LDA POS5
        ANI 0FH
        RLC
        RLC
        RLC
        RLC
        MOV B,A
        LDA POS6
        ANI 0FH
        ADD B
        MOV M,A
        STA POSC
        JMP SALTO5
SALTO1  INX H
        SHLD POS9
        CALL SEPDIR
        JMP SALTO5
SALTO2  DCX H
        SHLD POS9
        CALL SEPDIR
        JMP SALTO5
SALTO3  MVI A,0FH        ;F
        STA POS1
        MVI A,12H        ;I
        STA POS2
        MVI A,17H        ;N
        STA POS3
        MVI A,29H        ;QUE SUMADO A 37 (60 EN ASCII) DISPLAY VACIO
        STA POS4
        STA POS5
        STA POS6
        CALL DISPLAY
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

ERROR   PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI C,05H
ERR1    MVI A,0EH
        STA POS1
        CALL BORRAR
        MVI A,45H        ;"ERROR" EN ASCII
        STA POSTEX0
        MVI A,52H
        STA POSTEX1
        STA POSTEX2
        STA POSTEX4
        MVI A,4FH
        STA POSTEX3
        MVI A,20H
        STA POSTEX5
        STA POSTEX6
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
TEMP1   MVI D,0FFH
TEM1    MVI E,0FFH
TEM2    DCR E
        JNZ TEM2
        DCR D
        JNZ TEM1
        DCR C
        MVI A,00H
        CMP C
        JNZ TEMP2
        MVI A,01H
        STA POS7
        CALL DISPLAY 
        POP D
        POP B
        POP PSW
        POP H
        RET
TEMP2   MVI A,20H        ;ESPACIO EN ASCII
        STA POSTEX0
        STA POSTEX1
        STA POSTEX2
        STA POSTEX3
        STA POSTEX4
        STA POSTEX5
        STA POSTEX6 
        STA POSTEX7
        MVI D,0FFH
TEM3    MVI E,0FFH
TEM4    DCR E
        JNZ TEM4
        DCR D
        JNZ TEM3
        JMP ERR1
        DS 20H


TECLADO PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        LDA POSSE
        CPI 01H
        JZ TECLASE











FIN1    MOV A,H
        ADD L
        MOV L,A
        MVI H,0EH
        MOV A,M
        STA POS0
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H


REG     PUSH PSW
        STA POSE
        MOV A,B
        STA POSF
        MOV A,C
        STA POS10
        MOV A,D
        STA POS11
        MOV A,E
        STA POS12
        SHLD POS13
        POP H
        MOV A,L
        STA POSD
        LXI H,POS0
        LXI B,POS17
OTRO    MOV A,M
        STAX B
        INX B
        INX H
        MOV A,L
        CPI 0DH
        JNZ OTRO
REG2    POP H
        MVI A,50H        ;"P" EN ASCII
        STA POSTEX0
        MVI A,2EH        ;"." EN ASCII
        STA POSTEX1
        MVI A,43H        ;"C" EN ASCII
        STA POSTEX2
        MVI A,2EH        ;"." EN ASCII
        STA POSTEX3
        MVI A,20H        ;"ESPACIO" EN ASCII
        STA POSTEX4
        STA POSTEX5
        STA POSTEX6
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
        CALL CAMBIA
        SHLD POS15
        LXI H,00H
        DAD SP
        MVI A,52H        ;"S" EN ASCII
        STA POSTEX0
        MVI A,54H        ;"T" EN ASCII
        STA POSTEX1
        MVI A,41H        ;"A" EN ASCII
        STA POSTEX2
        MVI A,43H        ;"C" EN ASCII
        STA POSTEX3
        MVI A,4BH        ;"K" EN ASCII
        STA POSTEX4
        MVI A,20H        ;"ESPACIO" EN ASCII
        STA POSTEX5
        STA POSTEX6
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
        CALL CAMBIA
        SPHL
        LHLD POS15
        PUSH H
        LHLD POSD
        MVI A, 41H       ;"A" EN ASCII
        STA POSTEX0
        MVI A,2EH        ;"." EN ASCII
        STA POSTEX1
        STA POSTEX3
        MVI A,52H        ;"R" EN ASCII
        STA POSTEX2
        MVI A,20H        ;"ESPACIO" EN ASCII
        STA POSTEX3
        STA POSTEX4
        STA POSTEX5
        STA POSTEX6
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
        CALL CAMBIA
        PUSH H
        LHLD POSF
        MVI A,52H        ;"R"
        STA POSTEX0
        MVI A,45H        ;"E"
        STA POSTEX1
        MVI A,47H        ;"G"
        STA POSTEX2
        MVI A,2EH        ;"."
        STA POSTEX3
        MVI A,20H        ;" "
        STA POSTEX4
        MVI A,42H        ;"B"
        STA POSTEX5
        MVI A,2DH        ;"-"
        STA POSTEX6
        MVI A,43H        ;"C"
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
        CALL CAMBIA
        PUSH H
        LHLD POS11
        MVI A,52H        ;"R"
        STA POSTEX0
        MVI A,45H        ;"E"
        STA POSTEX1
        MVI A,47H        ;"G"
        STA POSTEX2
        MVI A,2EH        ;"."
        STA POSTEX3
        MVI A,20H        ;" "
        STA POSTEX4
        MVI A,44H        ;"D"
        STA POSTEX5
        MVI A,2DH        ;"-"
        STA POSTEX6
        MVI A,45H        ;"E"
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
        CALL CAMBIA
        PUSH H
        LHLD POS13
        MVI A,52H        ;"R"
        STA POSTEX0
        MVI A,45H        ;"E"
        STA POSTEX1
        MVI A,47H        ;"G"
        STA POSTEX2
        MVI A,2EH        ;"."
        STA POSTEX3
        MVI A,20H        ;" "
        STA POSTEX4
        MVI A,48         ;"H"
        STA POSTEX5
        MVI A,2DH        ;"-"
        STA POSTEX6
        MVI A,4CH        ;"L"
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY 
        CALL CAMBIA
        JMP REG2
FINI    PUSH H
        LXI H,POS17
        LXI B,POS0
OTRO2   MOV A,M
        STAX B
        INX B
        INX H
        MOV A,L
        CPI 24H
        JNZ OTRO2
        MVI A,18H
        SIM
        EI
        POP H
        POP D
        POP B
        POP PSW
        RET
CAMBIA  PUSH PSW
        PUSH B
        PUSH D
        SHLD POS9
SIGUE1  CALL SEPDIR
        CALL DISPLAY
SIGUE2  CALL TECLADO
        LHLD POS9
        LDA POS0
        CPI 13H
        JZ ACABA
        MVI B,10H
        CMP B
        JNZ TECFIN
        CALL OBTDIR
        JMP SIGUE1
TECFIN  CPI 16H
        JZ FINI
        JMP SIGUE2
ACABA   POP D
        POP B
        POP PSW
        RET
        DS 20H

PEPRO   PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI A,00H
        STA 3000H
        CALL BORRAR
        MVI A,47         ;"G"
        STA POSTEX0
        MVI A,52H        ;"R"
        STA POSTEX1
        MVI A,2EH        ;"."
        STA POSTEX2
        MVI A,45H        ;"E"
        STA POSTEX3
        MVI A,50H        ;"P"
        STA POSTEX4
        MVI A,52H        ;"R"
        STA POSTEX5
        MVI A,4FH        ;"O"
        STA POSTEX6
        MVI A,4DH        ;"M"
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL BORRAR
        CALL DISPLAY
        CALL RETARDO
        MVI A,52H        ;"R"
        STA POSTEX0
        MVI A,41H        ;"A"
        STA POSTEX1
        MVI A,4DH        ;"M"
        STA POSTEX2
        MVI A,20H        ;" "
        STA POSTEX3
        MVI A,49H        ;"I"
        STA POSTEX4
        MVI A,4EH        ;"N"
        STA POSTEX5
        MVI A,49H        ;"I"
        STA POSTEX6
        MVI A,43H        ;"C"
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL BORRAR
        CALL DISPLAY
EP2     CALL OBTDIR
        LDA POSA
        MOV H,A
        LDA POS9
        MOV L,A
        CALL TECLADO
        LDA POS0
        CPI 16H
        JNZ EP2
        MVI A,52H        ;"R"
        STA POSTEX0
        MVI A,41H        ;"A"
        STA POSTEX1
        MVI A,4DH        ;"M"
        STA POSTEX2
        MVI A,20H        ;ESPACIO
        STA POSTEX3
        MVI A,46H        ;"F"
        STA POSTEX4
        MVI A,49H        ;"I"
        STA POSTEX5
        MVI A,4EH        ;"N"
        STA POSTEX6
        MVI A,20H        ;ESPACIO
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL DISPLAY
EP4     CALL OBTDIR
        LDA POSA
        MOV B,A
        LDA POS9
        MOV C,A
        CALL TECLADO
        LDA POS0
        CPI 16H
        JNZ EP4
EP3     MVI A,44H        ;"D"
        STA POSTEX0
        MVI A,49H        ;"I"
        STA POSTEX1
        MVI A,52H        ;"R"
        STA POSTEX2
        MVI A,2EH        ;"."
        STA POSTEX3
        MVI A,45H        ;"E"
        STA POSTEX4
        MVI A,50H        ;"P"
        STA POSTEX5
        MVI A,52H        ;"R"
        STA POSTEX6
        MVI A,4FH        ;"O"
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL BORRAR
        CALL DISPLAY
EP5     CALL OBTDIR
        LDA POSA
        MOV D,A
        LDA POS9
        MOV E,A
EP1     MVI A,03H        ;PUERTOS A Y B COMO SALIDAS
        STA 3000H
        MVI A,01H        ;PARTE ALTA DIR.
        STA 3001H
        MOV A,D          
        STA 3002H        ;MANDA LA PARTE ALTA DE DIR. POR B
        MVI A,02H  
        STA 3001H        ;PARTE BAJA DIR
        MOV A,E
        STA 3002H        ;MANDA POR PUERTO B PARTE BAJA DIR.
        MVI A,4CH        ;PONEMOS VPP,OE,PGM="1" Y LH,LL,CE="0"
        STA 3001H
        MOV A,M
        STA 3002H        ;MANDAMOS EL DATO A ESCRIBIR AL PUERTO B
        MVI A,0CH
        STA 3001H        ;PONEMOS PGM="0" DURANTE 50 MILISEG.
        PUSH D           ;RETARDO
        MVI D,30H        ;DE
EP6     MVI E,0FFH       ;50 
EP7     DCR E            ;MILISEGUNDOS
        JNZ EP7          ;
        DCR D            ;
        JNZ EP6          ;
        POP D            ;
        MVI A,4CH  
        STA 3001H        ;PONEMOS PGM="1" Y VPP CONTINUA A "1"
        MVI A,01H
        STA 3000H        ;PUERTO A COMO SALIDAS Y PUERTO B COMO ENTRADAS
        MVI A,44H  
        STA 3001H        ;LH,LL,OE,CE="0" Y PGM,VPP="1"
        LDA 3002H
        CMP M            ;COMPARAMOS EL DATO ESCRITO
        JNZ PERROR
        MVI A,4CH
        STA 3001H        ; OE="1" PGM Y VPP TAMBIEN
        INX D
        INX H
        MOV A,H
        CMP B
        JNZ EP1
        MOV A,L
        CMP C
        JNZ EP1
        MVI A,00H
        STA 3000H        ;PONEMOS A Y B COMO ENTRADAS PARA DESACTIVARLO
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

PASO    DI
        SHLD POS26
        POP H
        SHLD POS9
        PUSH H
        PUSH PSW
        CALL SEPDIR
        MVI A,50H        ;"P"
        STA POSTEX0
        MVI A,41H        ;"A"
        STA POSTEX1
        MVI A,53H        ;"S"
        STA POSTEX2
        MVI A,4FH        ;"O"
        STA POSTEX3
        MVI A,20H        ;ESPACIO
        STA POSTEX4
        STA POSTEX5
        STA POSTEX6
        STA POSTEX7
        MVI A,0H
        STA POSTEX8
        CALL BORRAR
        CALL DISPLAY
        MOV A,M
        STA POSC
        CALL SEPDAT
        CALL BORRAR
        CALL DISPLAY  
PASO1   CALL TECLADO
        LDA POS0
        CPI 15H
        JNZ PASO1
        MVI A,18H
        SIM
        EI
        LHLD POS26
        POP PSW
        RET
        DS 20H




;RUTINA SELECCION DE BAUDIOS

INI     PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI A,42H        ;"B"
        STA POSTEX0
        MVI A,41H        ;"A"
        STA POSTEX1
        MVI A,55H        ;"U"
        STA POSTEX2
        MVI A,44H        ;"D"
        STA POSTEX3
        MVI A,49H        ;"I"
        STA POSTEX4
        MVI A,4FH        ;"O"
        STA POSTEX5
        MVI A,53H        ;"S"
        STA POSTEX6
        MVI A,20H        ;ESPACIO
        STA POSTEX7
        CALL DISPLAY
SLTO0   CALL OBTDIR
        LHLD POS9
        MOV A,H
        CPI 19H
        JZ SLTO1
        CPI 96H
        JZ SLTO2
        CPI 48H
        JZ SLTO3
        CPI 24H
        JZ SLTO4
        CPI 12H
        JZ SLTO5
        CPI 06H
        JZ SLTO6
        CPI 03H
        JZ SLTO7
        CPI 01H
        JNZ SLTO8
        MOV A,L
        CPI 50H
        JZ SLTO9
        CPI 10H
        JZ SLTO10
SLTO8   CALL ERROR
        JMP SLTO0
SLTO1   LXI H,0107H
        SHLD POSV
        LXI H,0104H
        SHLD POSV1
        JMP SLTO11
SLTO2   LXI H,0112H
        SHLD POSV
        LXI H,0109H
        SHLD POSV1
        JMP SLTO11
SLTO3   LXI H,0129H
        SHLD POSV
        LXI H,0115H
        SHLD POSV1
        JMP SLTO11
SLTO4   LXI H,0157H
        SHLD POSV
        LXI H,012CH
        SHLD POSV1
        JMP SLTO11
SLTO5   LXI H,01B2H
        SHLD POSV
        LXI H,0159H
        SHLD POSV1
        JMP SLTO11
SLTO6   LXI H,0269H
        SHLD POSV
        LXI H,01A5H
        SHLD POSV1
        JMP SLTO11
SLTO7   LXI H,0307H
        SHLD POSV
        LXI H,026CH
        SHLD POSV1
        JMP SLTO11
SLTO9   LXI H,06B2H
        SHLD POSV
        LXI H,03D9H
        SHLD POSV1
        JMP SLTO11
SLTO10  LXI H,08C6H
        SHLD POSV
        LXI H,04E3H
        SHLD POSV1
        JMP SLTO11
SLTO11  POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H




ENVIO   NOP
E1      MOV C,M
        XRA A
        ORA C
        RZ
        CALL COUT
        INX H
        JMP E1
COUT    DI
        PUSH B
        PUSH H
        MVI B,0B        ;Bites de salida
        XRA A
CO1     MVI A,80H
        RAR
        SIM
        LHLD POSV
CO2     DCR L
        JNZ CO2
        DCR H
        JNZ CO2
        STC
        MOV A,C
        RAR
        MOV C,A
        DCR B
        JNZ CO1
        POP H
        POP B
        EI
        RET
        DS 20H

CINP    DI
        PUSH H
        MVI B,09H
CI1     RIM
        ORA A
        JM CI1
        LHLD POSV1
CI2     DCR L
        JNZ CI2
        DCR H
        JNZ CI2
CI3     LHLD POSV
CI4     DCR L
        JNZ CI4
        DCR H
        JNZ CI4
        RIM
        RAL
        DCR B
        JZ CI5
        MOV A,C
        RAR
        MOV C,A
        NOP
        JMP CI3
CI5     POP H
        EI
        RET
        DS 20H


PERROR  SHLD POS9
        CALL SEPDIR
        MVI A,45H
        STA POSTEX0
        MVI A,52H
        STA POSTEX1
        STA POSTEX2
        STA POSTEX4
        MVI A,4FH
        STA POSTEX3
        MVI A,20H
        STA POSTEX5
        STA POSTEX6
        STA POSTEX7
        CALL DISPLAY
        CALL RETARDO
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H

RETARDO PUSH H
        PUSH PSW
        PUSH B
        PUSH D
        MVI D,0FFH
RETA1   MVI E,0FFH
RETA2   DCR E
        JNZ RETA2
        DCR D
        JNZ RETA1
        POP D
        POP B
        POP PSW
        POP H
        RET
        DS 20H


;RUTINA DE RECIBIR DATOS EN PARALELO(*.OBJ o *.NTL)-MEJOR NTL-  
         
    
PARAL    PUSH H
         PUSH PSW
         PUSH B
         PUSH D
         MVI A,86H     ;PUERTO B ENTRADAS MODO 1 (TRANSFERENCIA DE DATOS)
         STA PORTCR
INICIO   CALL LEER
         CPI 3AH
         JNZ INICIO
         CALL LEER ;
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         CALL ROTAR
         MOV D,A
         CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         ADD D
         CPI 0
         MOV D,A
         JZ ADIOS
         CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         CALL ROTAR
         MOV H,A
         CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         ADD H
         MOV H,A
         CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         CALL ROTAR
         MOV L,A
         CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         ADD L
         MOV L,A
         CALL LEER
         CALL LEER
DATOS    CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         CALL ROTAR
         MOV B,A
         CALL LEER
         ANI 0F0H
         CPI 30H
         CNZ LETRA
         CZ NUMERO
         ADD B
         MOV B,A
         MOV M,A
         INX H
         DCR D
         JNZ DATOS
         CALL LEER
         JMP INICIO
LEER     LDA 7000H
         ANI 02H
         CPI 02H
         JNZ LEER
         LDA 7001H
         MOV C,A
         RET
LETRA    MOV A,C
         ANI 0FH
         ADI 09H
         RET
NUMERO   MOV A,C
         ANI 0FH
         RET
ROTAR    RLC
         RLC
         RLC
         RLC
         RET
ADIOS    MVI A,0FFH
         STA 7000H
         CALL BORRAR
         POP D
         POP B
         POP PSW
         POP H
         RET
         DS 10H



BORRAR   MVI A,29H       ;BORRA POSICIONES DE TEXTO CON DATOS Y DIRECCIONES 
         STA POS0
         STA POS1
         STA POS3
         STA POS4
         STA POS5
         STA POS6
         STA POS2
        

BINAR   MVI H,20H
        MVI L,4FH        ;HL CON LA POSICION 204FH
        LDA POSC         ;POSICION DEL DATO
        MOV D,A          ;GUARDAMOS ACU EN "D"
BINR2   MOV A,D          ;CARGAMOS EL ACUMULADOR CON "D"
        ANI 01H          ;NOS QUEDAMOS CON EL BIT BAJO SOLO.
        ADI 30H          ;LE SUMAMOS 30 PARA CONVERTIR EL "0" O "1" A ASCII
        MOV M,A          ;LO DEJAMOS EN UNA POSICION DE MEMORIA.
        DCX H
        MOV A,L          ;COMPARAMOS
        CPI 47H          ;POSICION ULTIMA -1 (204FH-(8 DATOS)-1)
        JNZ BINR1
        MVI A,20H        ;ESPACIO EN ASCII
        STA 2040H
        STA 2045H
        STA 2046H
        STA 2047H
        MVI A,44H        ;"D"
        STA 2041H
        MVI A,41H        ;"A"
        STA 2042H
        MVI A,54H        ;"T"
        STA 2043H
        MVI A,4FH        ;"O"
        STA 2044H
        POP D
        POP B
        POP PSW
        POP H
        RET
BINR1   MOV A,D          ;RECUPERAMOS EL ACU GUARDADO EN "D"
        RRC
        MOV D,A
        JMP BINR2
        DS 20H

